package org.framework.lazy.cloud.network.heartbeat.client.netty.proxy.http.advanced;

import io.netty.buffer.ByteBuf;
import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import lombok.extern.slf4j.Slf4j;
import org.framework.lazy.cloud.network.heartbeat.client.netty.proxy.http.handler.NettyHttpServerProxyClientRealHandler;
import org.framework.lazy.cloud.network.heartbeat.common.NettyProxyMsg;
import org.framework.lazy.cloud.network.heartbeat.common.advanced.proxy.http.client.AbstractHandleHttpDistributeServerProxyClientTransferRequestTypeAdvanced;
import org.framework.lazy.cloud.network.heartbeat.common.utils.ChannelAttributeKeyUtils;
import org.wu.framework.core.utils.ObjectUtils;

/**
 * @see NettyHttpServerProxyClientRealHandler
 */
@Slf4j
public class ClientHandleDistributeHttpServerProxyClientTransferRequestAdvanced extends
        AbstractHandleHttpDistributeServerProxyClientTransferRequestTypeAdvanced<NettyProxyMsg> {


    /**
     * 处理当前数据
     *
     * @param channelHandlerContext       当前通道
     * @param nettyProxyMsg 通道数据
     */
    @Override
    protected void doHandler(ChannelHandlerContext channelHandlerContext, NettyProxyMsg nettyProxyMsg) {
        Channel channel = channelHandlerContext.channel();
        // 数据发送
        Channel nextChannel = ChannelAttributeKeyUtils.getNextChannel(channel);
        if (ObjectUtils.isNotEmpty(nextChannel)) {
            ByteBuf buf = channel.config().getAllocator().buffer(nettyProxyMsg.getData().length);
            buf.writeBytes(nettyProxyMsg.getData());
            nextChannel.writeAndFlush(buf);
        } else {
            log.error("客户端代理到另一个客户端，发送请求到目标客户端但是未找到真实通道");
        }

    }
}
